<template>
  <main>
    <mt-page-title
      :link-to="{ name: 'profil-dashboard-typesOrganismes', params: { profil: 'admin' } }"
      link-text="Annuler"
    >
      <h1 class="has-text-weight-bold is-size-3">création d'un type d'organisme</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-champs-form-type-organisme
        :type-organisme="typeOrganisme"
        :types-organismes-parents="typesOrganismesParents"
      />
      <div class="columns is-centered">
        <b-button type="is-primary has-text-weight-semibold" native-type="submit">
          Créer le type d'organisme
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtChampsFormTypeOrganisme from '~/components/dashboard/typeOrganisme/champs-form-type-organisme';
import newTypeOrganisme from '~/components/mixins/typeOrganismeMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtChampsFormTypeOrganisme,
  },
  async asyncData(context) {
    const typeOrganisme = newTypeOrganisme();
    const typesOrganismesParents = await context.$api.typesOrganismes.all(0, 50);
    return {
      typeOrganisme,
      typesOrganismesParents,
    };
  },
  methods: {
    async submit() {
      try {
        await this.$api.typesOrganismes.post(this.typeOrganisme);
        this.$router.push({ name: 'profil-dashboard-types-organismes', params: { profil: 'admin' } });
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss"></style>
